#include <H5Tpublic.h>
#include <bindings.cmacros.h>

BC_INLINE_(H5T_IEEE_F32BE,      hid_t)
BC_INLINE_(H5T_IEEE_F32LE,      hid_t)
BC_INLINE_(H5T_IEEE_F64BE,      hid_t)
BC_INLINE_(H5T_IEEE_F64LE,      hid_t)

BC_INLINE_(H5T_STD_I8BE,        hid_t)
BC_INLINE_(H5T_STD_I8LE,        hid_t)
BC_INLINE_(H5T_STD_I16BE,       hid_t)
BC_INLINE_(H5T_STD_I16LE,       hid_t)
BC_INLINE_(H5T_STD_I32BE,       hid_t)
BC_INLINE_(H5T_STD_I32LE,       hid_t)
BC_INLINE_(H5T_STD_I64BE,       hid_t)
BC_INLINE_(H5T_STD_I64LE,       hid_t)
BC_INLINE_(H5T_STD_U8BE,        hid_t)
BC_INLINE_(H5T_STD_U8LE,        hid_t)
BC_INLINE_(H5T_STD_U16BE,       hid_t)
BC_INLINE_(H5T_STD_U16LE,       hid_t)
BC_INLINE_(H5T_STD_U32BE,       hid_t)
BC_INLINE_(H5T_STD_U32LE,       hid_t)
BC_INLINE_(H5T_STD_U64BE,       hid_t)
BC_INLINE_(H5T_STD_U64LE,       hid_t)
BC_INLINE_(H5T_STD_B8BE,        hid_t)
BC_INLINE_(H5T_STD_B8LE,        hid_t)
BC_INLINE_(H5T_STD_B16BE,       hid_t)
BC_INLINE_(H5T_STD_B16LE,       hid_t)
BC_INLINE_(H5T_STD_B32BE,       hid_t)
BC_INLINE_(H5T_STD_B32LE,       hid_t)
BC_INLINE_(H5T_STD_B64BE,       hid_t)
BC_INLINE_(H5T_STD_B64LE,       hid_t)
BC_INLINE_(H5T_STD_REF_OBJ,     hid_t)
BC_INLINE_(H5T_STD_REF_DSETREG, hid_t)

BC_INLINE_(H5T_UNIX_D32BE,      hid_t)
BC_INLINE_(H5T_UNIX_D32LE,      hid_t)
BC_INLINE_(H5T_UNIX_D64BE,      hid_t)
BC_INLINE_(H5T_UNIX_D64LE,      hid_t)

BC_INLINE_(H5T_C_S1,            hid_t)

BC_INLINE_(H5T_FORTRAN_S1,      hid_t)

BC_INLINE_(H5T_VAX_F32,         hid_t)
BC_INLINE_(H5T_VAX_F64,         hid_t)

BC_INLINE_(H5T_NATIVE_CHAR,     hid_t)
BC_INLINE_(H5T_NATIVE_SCHAR,    hid_t)
BC_INLINE_(H5T_NATIVE_UCHAR,    hid_t)
BC_INLINE_(H5T_NATIVE_SHORT,    hid_t)
BC_INLINE_(H5T_NATIVE_USHORT,   hid_t)
BC_INLINE_(H5T_NATIVE_INT,      hid_t)
BC_INLINE_(H5T_NATIVE_UINT,     hid_t)
BC_INLINE_(H5T_NATIVE_LONG,     hid_t)
BC_INLINE_(H5T_NATIVE_ULONG,    hid_t)
BC_INLINE_(H5T_NATIVE_LLONG,    hid_t)
BC_INLINE_(H5T_NATIVE_ULLONG,   hid_t)
BC_INLINE_(H5T_NATIVE_FLOAT,    hid_t)
BC_INLINE_(H5T_NATIVE_DOUBLE,   hid_t)
#if H5_SIZEOF_LONG_DOUBLE !=0
BC_INLINE_(H5T_NATIVE_LDOUBLE,  hid_t)
#endif
BC_INLINE_(H5T_NATIVE_B8,       hid_t)
BC_INLINE_(H5T_NATIVE_B16,      hid_t)
BC_INLINE_(H5T_NATIVE_B32,      hid_t)
BC_INLINE_(H5T_NATIVE_B64,      hid_t)
BC_INLINE_(H5T_NATIVE_OPAQUE,   hid_t)
BC_INLINE_(H5T_NATIVE_HADDR,    hid_t)
BC_INLINE_(H5T_NATIVE_HSIZE,    hid_t)
BC_INLINE_(H5T_NATIVE_HSSIZE,   hid_t)
BC_INLINE_(H5T_NATIVE_HERR,     hid_t)
BC_INLINE_(H5T_NATIVE_HBOOL,    hid_t)

BC_INLINE_(H5T_NATIVE_INT8,         hid_t)
BC_INLINE_(H5T_NATIVE_UINT8,        hid_t)
BC_INLINE_(H5T_NATIVE_INT_LEAST8,   hid_t)
BC_INLINE_(H5T_NATIVE_UINT_LEAST8,  hid_t)
BC_INLINE_(H5T_NATIVE_INT_FAST8,    hid_t)
BC_INLINE_(H5T_NATIVE_UINT_FAST8,   hid_t)

BC_INLINE_(H5T_NATIVE_INT16,        hid_t)
BC_INLINE_(H5T_NATIVE_UINT16,       hid_t)
BC_INLINE_(H5T_NATIVE_INT_LEAST16,  hid_t)
BC_INLINE_(H5T_NATIVE_UINT_LEAST16, hid_t)
BC_INLINE_(H5T_NATIVE_INT_FAST16,   hid_t)
BC_INLINE_(H5T_NATIVE_UINT_FAST16,  hid_t)

BC_INLINE_(H5T_NATIVE_INT32,        hid_t)
BC_INLINE_(H5T_NATIVE_UINT32,       hid_t)
BC_INLINE_(H5T_NATIVE_INT_LEAST32,  hid_t)
BC_INLINE_(H5T_NATIVE_UINT_LEAST32, hid_t)
BC_INLINE_(H5T_NATIVE_INT_FAST32,   hid_t)
BC_INLINE_(H5T_NATIVE_UINT_FAST32,  hid_t)

BC_INLINE_(H5T_NATIVE_INT64,        hid_t)
BC_INLINE_(H5T_NATIVE_UINT64,       hid_t)
BC_INLINE_(H5T_NATIVE_INT_LEAST64,  hid_t)
BC_INLINE_(H5T_NATIVE_UINT_LEAST64, hid_t)
BC_INLINE_(H5T_NATIVE_INT_FAST64,   hid_t)
BC_INLINE_(H5T_NATIVE_UINT_FAST64,  hid_t)
